﻿/*
    Program ukazujici praci s tridou Thread.
*/

using System;
using System.Threading;

namespace Counter
{
    class Program
    {
        private static int count;
        private static object theLock = new object();

        static void Main(string[] args)
        {
            Thread t1 = new Thread(Counter);
            Thread t2 = new Thread(Counter);
            Thread t3 = new Thread(Counter);

            t1.Name = "Thread 1";
            t2.Name = "Thread 2";
            t3.Name = "Thread 3";
            t1.Start();
            t2.Start();
            t3.Start();
        }

        public static void Counter()
        {
            while (true)
            {
                lock (theLock)
                {
                    if (count >= 20)
                    {
                        break;
                    }
                    count++;
                    Console.WriteLine("{0}: {1,2}",
                        Thread.CurrentThread.Name, count);
                    Thread.Sleep(70);
                }
            }
        }

    }
}
