﻿/*
    Program ukazujici pouziti tridy ThreadPool 1.
*/

using System;
using System.Threading;

namespace ThreadPool1
{
    class Program
    {
        private static AutoResetEvent are = new AutoResetEvent(false);

        public static void Main()
        {
            RegisteredWaitHandle rwh = 
                ThreadPool.RegisterWaitForSingleObject
                (are, DoWork, "ahoj", -1, true);

            Console.WriteLine("Signalizace pracovnímu vláknu...");
            are.Set();
            are.WaitOne();

            Console.WriteLine("Činnost pracovního vlákna ukončena.");

            rwh.Unregister(are);
        }

        public static void DoWork(object data, bool timedOut)
        {
            Console.WriteLine("Započato - " + data
                + ", Time out: " + timedOut);

            //Provedeni prace
            Thread.Sleep(2000);

            Console.WriteLine("Práce dokončena");

            are.Set();
        }
    }
}



